// LZHW Encode
#include "LZ77.h"
#include "hw.h"

#define DIC_BITS		12		// TCỸrbg
#define CODE_BITS		4		// őṽrbg
#define WORDS_SIZE		((1 << DIC_BITS) + (1 << CODE_BITS) + 2)	// nbVe[uQTCYiTCY + őv, 4096 + 18j
#define HASH_SIZE		0xFFFF	// nbVe[uTCY

typedef struct SDIC
{
	int	*buffer;
	int dic_len,code_len;
	int buf_size;
	int dic_bgn;
	int code_bgn,code_end;
}SlideDic;

typedef struct
{
	int		prev;	// O̔ԍ
	int		next;	// ̔ԍ
	WORD	hash;	// nbVl
	bool	flag;	// f[^LtO
}WORDS,*PWORDS;

typedef struct
{
	WORDS	data[WORDS_SIZE];
	int		end;
}WORDS2,*PWORDS2;

DATA	g_dstLZ77 = {0};

BYTE	*g_pDataSrcLZ77 = NULL;

bool	__stdcall Decompress(BYTE *pData, int size, TCHAR *filenameR);
bool	__stdcall Decompress(BYTE *pDataDst, int sizeDst, BYTE *pDataSrc, int sizeSrc);
int		__stdcall getDistance(int x1, int x2, int size);
void	__stdcall insertOneCodeToDic(SlideDic *sdic, int c);
bool	__stdcall decodeLZ77(BYTE *dataSrc, int *ctSrc, int size, BYTE *pData, int dic_bits, int code_bits);
bool	__stdcall Compress(TCHAR *filenameW, TCHAR *filenameR);
bool	__stdcall Compress(DATA *data, TCHAR *filenameR);
WORD	__stdcall Get_Hash(int a, int b, int c);
int		__stdcall nextPos(int now, int bsize);
bool	__stdcall initSlideDic(SlideDic *sdic, int dic, int code);
int		__stdcall getMatchLength(SlideDic *sdic, int pos);
void	__stdcall getMatchPattern(SlideDic *sdic, WORDS *words, int index, int *pos, int *len);
void	__stdcall insertCodeToDic(SlideDic *sdic, int c);
void	__stdcall slideDic(SlideDic *sdic);
bool	__stdcall encodeLZ77(BYTE *data, int size);
int		__stdcall getPow2(int x);
void	__stdcall Free_Data(DATA *data);

bool __stdcall Decompress(BYTE *pData, int size, TCHAR *filenameR)
{
	if(!pData){
		return 0;
	}
	
	FILE			*fpR;
	int				ctSrc = 0;
	int				size2,dic,code;
	unsigned int	c,ct,sizeR;
	fpos_t			pos;
	
	if(_tfopen_s(&fpR, filenameR, TEXT("rb"))){
		return 0;
	}
	fseek(fpR, 0, SEEK_END);
	fgetpos(fpR, &pos);
	rewind(fpR);
	sizeR = (unsigned int) pos;
	fclose(fpR);
	
	BYTE *pDataSrc = (BYTE *) malloc(sizeR);
	if(!pDataSrc){
		return 0;
	}
	
	if(_tfopen_s(&fpR, filenameR, TEXT("rb"))){
		FREE(pDataSrc);
        return 0;
    }
	ct = 0;
	while((c = fgetc(fpR)) != EOF){
		pDataSrc[ct] = c;
		ct ++;
	}
	fclose(fpR);
	
	size2 = getLong(pDataSrc, &ctSrc);
	dic   = getLong(pDataSrc, &ctSrc);
	code  = getLong(pDataSrc, &ctSrc);
	if(size < size2){
		size2 = size;
	}
	
	bool ret = decodeHW(pDataSrc, &ctSrc);
	FREE(pDataSrc);
	if(ret){
		int	ctSrc2 = 0;
		ret = decodeLZ77(g_pDataDstHW, &ctSrc2, size2, pData, dic, code);
	}
	FREE(g_pDataDstHW);
	return ret;
}// Decompress

bool __stdcall Decompress(BYTE *pDataDst, int sizeDst, BYTE *pDataSrc, int sizeSrc)
{
	if(!pDataSrc || !pDataDst){
		return 0;
	}
	
	int ctSrc = 0;
	int	size2,dic,code;
	size2 = getLong(pDataSrc, &ctSrc);
	dic   = getLong(pDataSrc, &ctSrc);
	code  = getLong(pDataSrc, &ctSrc);
	if(sizeDst < size2){
		size2 = sizeDst;
	}
	bool ret = decodeHW(pDataSrc, &ctSrc);
	if(ret){
		int	ctSrc2 = 0;
		ret = decodeLZ77(g_pDataDstHW, &ctSrc2, size2, pDataDst, dic, code);
	}
	FREE(g_pDataDstHW);
	return ret;
}// Decompress

inline int __stdcall getDistance(int x1, int x2, int size)
{
	int sa;
	
	sa = x1 - x2;
	if(sa >= 0)	return sa;
	return sa + size;
}// getDistance

inline void __stdcall insertOneCodeToDic(SlideDic *sdic, int c)
{
	int bsize,sa;
	
	bsize = sdic->buf_size;
	sdic->buffer[sdic->code_bgn] = c;
	sdic->code_bgn = nextPos(sdic->code_bgn, sdic->buf_size);
	sa = getDistance(sdic->code_bgn, sdic->dic_bgn, bsize);
	if(sa > sdic->dic_len){
		sdic->dic_bgn = nextPos(sdic->dic_bgn, bsize);
	}
}// insertOneCodeToDic

bool __stdcall decodeLZ77(BYTE *dataSrc, int *ctSrc, int size, BYTE *pData, int dic_bits, int code_bits)
{
	if(!dataSrc || !ctSrc || !pData){
		return 0;
	}
	
	SlideDic sdic;
	int p,c,i,d_bgn,flg,pos,len,dic,code;
	
	ZeroMemory(&sdic, sizeof(sdic));
	
	dic  = getPow2(DIC_BITS);
	code = getPow2(CODE_BITS) + 2;
	
	p = 0;
	bits = 0;
	bdata = 0;
	if(!initSlideDic(&sdic, dic, code)){
		return 0;
	}
	while(p < size){
		flg = getBit(dataSrc, ctSrc);
		if(flg){
			pos = getBits(dataSrc, ctSrc, DIC_BITS);
			len = getBits(dataSrc, ctSrc, CODE_BITS) + 3;
			d_bgn = (sdic.dic_bgn + pos) % sdic.buf_size;
			for(i=0;i<len;i++){
				c = sdic.buffer[d_bgn];
				pData[p] = c;
				p ++;
				insertOneCodeToDic(&sdic, c);
				d_bgn = nextPos(d_bgn, sdic.buf_size);
			}
		}
		else{
			c = getBits(dataSrc, ctSrc, 8);
			pData[p] = c;
			p ++;
			insertOneCodeToDic(&sdic, c);
		}
	}
	FREE(sdic.buffer);
	return 1;
}// decodeLZ77

// f[^k
// filenameWF	[IN] ۑt@C
// filenameRF	[IN] ǂݍ݃t@C
// ߂l	F	isF0, F1j
bool __stdcall Compress(TCHAR *filenameW, TCHAR *filenameR)
{
	FILE			*fpR,*fpW;
	unsigned int	c,ct,size;
	fpos_t			pos;
	
	if(_tfopen_s(&fpR, filenameR, TEXT("rb"))){
        return 0;
    }
	fseek(fpR, 0, SEEK_END);
	fgetpos(fpR, &pos);
	rewind(fpR);
	size = (unsigned int) pos;
	FREE(g_pDataSrcLZ77);
	g_pDataSrcLZ77 = (BYTE *) malloc(size);
	if(!g_pDataSrcLZ77){
		return 0;
	}
	ct = 0;
	while((c = fgetc(fpR)) != EOF){
		g_pDataSrcLZ77[ct] = c;
		ct ++;
	}
	fclose(fpR);
	
	if(_tfopen_s(&fpW, filenameW, TEXT("wb"))){
		FREE(g_pDataSrcLZ77);
        return 0;
    }
	bool ret = encodeLZ77(g_pDataSrcLZ77, ct);
	fwrite(g_dstLZ77.buffer, sizeof(BYTE), g_dstLZ77.len, fpW);
	fclose(fpW);
	FREE(g_pDataSrcLZ77);
	Free_Data(&g_dstLZ77);
	return ret;
}// Compress

// f[^k
// data		F	[OUT] o̓f[^
// filenameRF	[IN] ǂݍ݃t@C
// ߂l	F	isF0, F1j
bool __stdcall Compress(DATA *data, TCHAR *filenameR)
{
	if(!data){
		return 0;
	}
	
	FILE			*fpR;
	unsigned int	c,ct,size;
	fpos_t			pos;
	
	if(_tfopen_s(&fpR, filenameR, TEXT("rb"))){
        return 0;
    }
	fseek(fpR, 0, SEEK_END);
	fgetpos(fpR, &pos);
	rewind(fpR);
	size = (unsigned int) pos;
	FREE(g_pDataSrcLZ77);
	g_pDataSrcLZ77 = (BYTE *) malloc(size);
	if(!g_pDataSrcLZ77){
		return 0;
	}
	ct = 0;
	while((c = fgetc(fpR)) != EOF){
		g_pDataSrcLZ77[ct] = c;
		ct ++;
	}
	fclose(fpR);
	bool ret = encodeLZ77(g_pDataSrcLZ77, ct);
	FREE(g_pDataSrcLZ77);
	data->len		= g_dstLZ77.len;
	data->buf_size	= g_dstLZ77.buf_size;
	data->buffer	= g_dstLZ77.buffer;
	return ret;
}// Compress

inline WORD __stdcall Get_Hash(int a, int b, int c)
{
	return (WORD)((a & 0xFF) << 7 | ((b >> 4) & 0xF) << 4 | ((c >> 5) & 0x7));
}// Get_Hash

inline int __stdcall nextPos(int now, int bsize)
{
	return (now + 1) % bsize;
}// nextPos

inline bool __stdcall initSlideDic(SlideDic *sdic, int dic, int code)
{
	int i,size;
	
	size = dic + code;
	FREE(sdic->buffer);
	sdic->buffer = (int *) malloc(sizeof(int)*size);
	if(sdic->buffer == NULL)	return 0;
	for(i=0;i<size;i++)	sdic->buffer[i] = 0;
	sdic->dic_len  = dic;
	sdic->code_len = code;
	sdic->buf_size = size;
	sdic->dic_bgn  = 0;
	sdic->code_bgn = 0;
	sdic->code_end = 0;
	return 1;
}// initSlideDic

inline int __stdcall getMatchLength(SlideDic *sdic, int pos)
{
	int len,codes,i,t,u;
	
	len   = 0;
	t     = pos;
	u     = sdic->code_bgn;
	codes = sdic->code_end - sdic->code_bgn;
	if(codes < 0)	codes += sdic->buf_size;
	for(i=0;i<codes;i++){
		if(sdic->buffer[t] != sdic->buffer[u])
			break;
		len ++;
		t = nextPos(t, sdic->buf_size);
		u = nextPos(u, sdic->buf_size);
	}
	return len;
}// getMatchLength

//pos: ʒuԂ
//len: Ԃ
inline void __stdcall getMatchPattern(SlideDic *sdic, WORDS *words, int index, int *pos, int *len)
{
	int index2,len2;
	
	*pos = -1;
	*len = -1;
	index2 = index;
	while(index2 != -1){
		len2 = getMatchLength(sdic, index2);
		if(*len < len2){
			*len = len2;
			*pos = index2 - sdic->dic_bgn;
		}
		index2 = words[index2].next;
	}
	if(*pos < 0)
		*pos += sdic->buf_size;
}// getMatchPattern

inline void __stdcall insertCodeToDic(SlideDic *sdic, int c)
{
	sdic->buffer[sdic->code_end] = c;
	sdic->code_end = nextPos(sdic->code_end, sdic->buf_size);
}// insertCodeToDic

inline void __stdcall slideDic(SlideDic *sdic)
{
	int dic_next,dic_size;
	
	dic_size = sdic->code_bgn - sdic->dic_bgn;
	if(dic_size < 0)
		dic_size += sdic->buf_size;
	sdic->code_bgn = nextPos(sdic->code_bgn, sdic->buf_size);
	
	if(dic_size >= sdic->dic_len){
		dic_next = nextPos(sdic->dic_bgn, sdic->buf_size);
		sdic->dic_bgn = dic_next;
	}
}// SlideDic

bool __stdcall encodeLZ77(BYTE *data, int size)
{
	if(!data){
		return 0;
	}
	
	g_dstLZ77.buf_size = sizeof(long) * 3;
	g_dstLZ77.len = 0;
	g_dstLZ77.buffer = (BYTE*) malloc(g_dstLZ77.buf_size);
	if(!g_dstLZ77.buffer){
		return 0;
	}
	
	FREE(g_srcHW.buffer);
	g_srcHW.buf_size = size;
	g_srcHW.len = 0;
	g_srcHW.buffer = (BYTE*) malloc(g_srcHW.buf_size);
	if(!g_srcHW.buffer){
		Free_Data(&g_dstLZ77);
		return 0;
	}
	
	FREE(g_dstHW.buffer);
	g_dstHW.buf_size = size;
	g_dstHW.len = 0;
	g_dstHW.buffer = (BYTE*) malloc(g_dstHW.buf_size);
	if(!g_dstHW.buffer){
		Free_Data(&g_dstLZ77);
		Free_Data(&g_srcHW);
		return 0;
	}
	
	int  i,pos1,pos2,pos3;
	BYTE val1,val2,val3;
	WORDS2	w1;
	for(i=0;i<WORDS_SIZE;i++){
		w1.data[i].prev = -1;
		w1.data[i].next = -1;
		w1.data[i].hash = 0;
		w1.data[i].flag = false;
	}
	w1.end = 0;
	int hash_tbl[HASH_SIZE];
	for(i=0;i<HASH_SIZE;i++){
		hash_tbl[i] = -1;
	}
	
	SlideDic	sdic;
	int			p,dic,code,init_size,pos,len;
	
	ZeroMemory(&sdic, sizeof(sdic));
	
	dic  = getPow2(DIC_BITS);
	code = getPow2(CODE_BITS) + 2;
	if(!initSlideDic(&sdic, dic, code)){
		return 0;
	}
	if(size < code)	init_size = size;
	else			init_size = code;
	
	p = 0;
	for(i=0;i<init_size;i++){
		insertCodeToDic(&sdic, data[p++]);
	}
	
	putLong(size,		&g_dstLZ77);
	putLong(DIC_BITS,	&g_dstLZ77);
	putLong(CODE_BITS,	&g_dstLZ77);
	bits = 0;
	bdata = 0;
	while(sdic.code_bgn != sdic.code_end){
		pos1 = sdic.code_bgn;
		pos2 = nextPos(pos1, sdic.buf_size);
		pos3 = nextPos(pos2, sdic.buf_size);
		val1 = (BYTE) sdic.buffer[pos1];
		val2 = (BYTE) sdic.buffer[pos2];
		val3 = (BYTE) sdic.buffer[pos3];
		WORD hash1 = Get_Hash(val1, val2, val3);
		if(hash_tbl[hash1] != -1){
			getMatchPattern(&sdic, w1.data, hash_tbl[hash1], &pos, &len);
		}
		else{
			len = 0;
		}
		if(len > 2){
			putBits(1, 1, &g_srcHW);
			putBits(pos, DIC_BITS, &g_srcHW);
			putBits(len-3, CODE_BITS, &g_srcHW);
		}
		else{
			putBits(0, 1, &g_srcHW);
			putBits(sdic.buffer[sdic.code_bgn], 8, &g_srcHW);
			len = 1;
		}
		for(i=0;i<len;i++){
			if(p < size){
				insertCodeToDic(&sdic, data[p++]);
			}
/*			else{
				if(dic < size)
					sdic.dic_bgn = nextPos(sdic.dic_bgn, sdic.buf_size);
			}
*/			slideDic(&sdic);
		}
		// nbVe[uPEQT̈̃f[^폜
		for(i=sdic.code_bgn;i!=sdic.dic_bgn;i=nextPos(i, sdic.buf_size)){
			int  prev  = w1.data[i].prev;
			int  next  = w1.data[i].next;
			WORD hash3 = w1.data[i].hash;
			bool flag  = w1.data[i].flag;
			if(prev != -1 || next != -1 || flag){
				if(flag && hash_tbl[hash3] == i){
					if(next == -1){
						hash_tbl[hash3] = -1;
					}
					else{
						w1.data[next].prev = -1;
						w1.data[next].hash = hash3;
						w1.data[next].flag = true;
						hash_tbl[hash3] = next;
					}
				}
				else{
					if(next == -1){
						if(prev != -1){
							w1.data[prev].next = -1;
						}
					}
					else{
						if(prev != -1){
							w1.data[prev].next = next;
							w1.data[next].prev = prev;
						}
					}
				}
				w1.data[i].prev = -1;
				w1.data[i].next = -1;
				w1.data[i].hash = 0;
				w1.data[i].flag = false;
			}
		}
		// nbVe[uPEQɃf[^ǉ
		for(i=0;i<len;i++){
			pos1 = w1.end;
			pos2 = nextPos(pos1, sdic.buf_size);
			pos3 = nextPos(pos2, sdic.buf_size);
			val1 = (BYTE) sdic.buffer[pos1];
			val2 = (BYTE) sdic.buffer[pos2];
			val3 = (BYTE) sdic.buffer[pos3];
			WORD hash2 = Get_Hash(val1, val2, val3);
			if(hash_tbl[hash2] == -1){
				hash_tbl[hash2] = w1.end;
				w1.data[w1.end].hash = hash2;
				w1.data[w1.end].flag = true;
			}
			else{
				int index = hash_tbl[hash2];
				bool flag1 = false;
				while(!flag1){
					if(w1.data[index].next == -1){
						w1.data[index].next = w1.end;
						w1.data[w1.end].prev = index;
						flag1 = true;
					}
					else{
						index = w1.data[index].next;
					}
				}
			}
			w1.end = pos2;
		}
	}
	FREE(sdic.buffer);
	flushBit(&g_srcHW);
	
	encodeHW(&g_dstHW, g_srcHW.buffer, g_srcHW.len);
	int posLZ77 = g_dstLZ77.len;
	g_dstLZ77.buf_size = g_dstLZ77.len + g_dstHW.len;
	g_dstLZ77.len = g_dstLZ77.buf_size;
	g_dstLZ77.buffer = (BYTE*) realloc(g_dstLZ77.buffer, g_dstLZ77.buf_size);
	if(!g_dstLZ77.buffer){
		Free_Data(&g_srcHW);
		Free_Data(&g_dstHW);
		return 0;
	}
	memcpy(g_dstLZ77.buffer + posLZ77, g_dstHW.buffer, g_dstHW.len);
	
	Free_Data(&g_srcHW);
	Free_Data(&g_dstHW);
	
	return 1;
}// encodeLZ77

inline int __stdcall getPow2(int x)
{
	int i,s;
	
	s = 1;
	for(i=0;i<x;i++)
		s *= 2;
	return s;
}// getPow2

inline void __stdcall Free_Data(DATA *data)
{
	if(!data){
		return;
	}
	
	FREE(data->buffer);
	data->buf_size = 0;
	data->len = 0;
}// Free_Data
