// bit operation for LZ77 & HW
#ifndef _BITOPE_H_
#define _BITOPE_H_

#ifndef FREE
#define	FREE(p)	if(p){free(p);p=NULL;}
#endif	// FREE

struct DATA
{
	BYTE	*buffer;
	int		buf_size;
	int		len;
};

extern int	bits, bdata;

inline void __stdcall readData(BYTE *dataDst, int len, BYTE *dataSrc, int *ctSrc)
{
	if(!dataDst || !dataSrc || !ctSrc){
		return;
	}
	memcpy(dataDst, dataSrc + *ctSrc, len);
	(*ctSrc) += len;
}// readData

inline int __stdcall getLong(BYTE *dataSrc, int *ctSrc)
{
	if(!dataSrc || !ctSrc){
		return 0;
	}
	
	BYTE buf[16];
	readData(buf, 4, dataSrc, ctSrc);
	return (buf[0] << 24 | buf[1] << 16 | buf[2] << 8 | buf[3]);
}// getLong

inline int __stdcall getShort(BYTE *dataSrc, int *ctSrc)
{
	if(!dataSrc || !ctSrc){
		return 0;
	}
	
	BYTE buf[16];
	readData(buf, 2, dataSrc, ctSrc);
	return (buf[0] << 8 | buf[1]);
}// getShort

inline int __stdcall getC(BYTE *dataSrc, int *ctSrc)
{
	if(!dataSrc || !ctSrc){
		return 0;
	}
	
	BYTE buf[16];
	readData(buf, 1, dataSrc, ctSrc);
	return buf[0];
}// getC

inline int __stdcall getBit(BYTE *dataSrc, int *ctSrc)
{
	if(!dataSrc || !ctSrc){
		return 0;
	}
	
	BYTE	bbuf;
	int		val;
	
	if(bits == 0){
		readData(&bbuf, 1, dataSrc, ctSrc);
		bdata = bbuf;
	}
	val = (bdata >> 7) & 1;
	bdata = (bdata << 1) & 0xff;
	bits ++;
	if(bits >= 8){
		bits = 0;
		bdata = 0;
	}
	return val;
}// getBit

inline int __stdcall getBits(BYTE *dataSrc, int *ctSrc, int bits)
{
	if(!dataSrc || !ctSrc){
		return 0;
	}
	
	int i,res;
	
	res = 0;
	for(i=0;i<bits;i++){
		res = res * 2;
		res += getBit(dataSrc, ctSrc);
	}
	return res;
}// getBits

// f[^ǉ
inline bool __stdcall addData(BYTE val, DATA *data)
{
	if(!data || !data->buffer)
		return false;
	if(data->len >= data->buf_size){
		data->buf_size = data->len + 1;
		data->buffer = (BYTE*) realloc(data->buffer, data->buf_size);
		if(!data->buffer)
			return false;
	}
	data->buffer[data->len ++] = val;
	return true;
}// addData

inline void __stdcall putLong(long num, DATA *data)
{
	addData((num >> 24) & 0xff, data);
	addData((num >> 16) & 0xff, data);
	addData((num >>  8) & 0xff, data);
	addData((num      ) & 0xff, data);
}// putLong

inline void __stdcall putBit(int bit, DATA *data)
{
	bdata = (bdata << 1) | bit;
	bits ++;
	if(bits >= 8){
		addData(bdata, data);
		bits = 0;
		bdata = 0;
	}
}// putBit

inline void __stdcall putBits(int val, int n, DATA *data)
{
	int i;
	for(i=n-1;i>=0;i--){
		putBit((val >> i) & 1, data);
	}
}// putBits

inline void __stdcall flushBit(DATA *data)
{
	for(int i=0;i<7;i++){
		putBit(0, data);
	}
}// flushBit

#endif	// _BITOPE_H_
